(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/platform-browser')) :
    typeof define === 'function' && define.amd ? define('search-highlighter', ['exports', '@angular/core', '@angular/platform-browser'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global["search-highlighter"] = {}, global.ng.core, global.ng.platformBrowser));
})(this, (function (exports, i0, i1) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);

    var SearchHighlighterService = /** @class */ (function () {
        function SearchHighlighterService() {
        }
        return SearchHighlighterService;
    }());
    SearchHighlighterService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: SearchHighlighterService, deps: [], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    SearchHighlighterService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: SearchHighlighterService, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: SearchHighlighterService, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root'
                    }]
            }], ctorParameters: function () { return []; } });

    var SearchHighlighterComponent = /** @class */ (function () {
        function SearchHighlighterComponent(sanitizer) {
            this.sanitizer = sanitizer;
            this.color = 'yellow'; // default yellow color
            this.query = '';
        }
        SearchHighlighterComponent.prototype.ngOnInit = function () {
            var _a, _b;
            // gets text from original content 
            this.replacedInputText = (_b = (_a = this.inputs) === null || _a === void 0 ? void 0 : _a.nativeElement) === null || _b === void 0 ? void 0 : _b.innerText;
        };
        /**
         * research on any changes in query/color
         */
        SearchHighlighterComponent.prototype.ngOnChanges = function () {
            this.search();
        };
        SearchHighlighterComponent.prototype.search = function () {
            var _a, _b, _c;
            // replacing the original content
            this.replacedInputText = this.sanitizer.bypassSecurityTrustHtml((_c = (_b = (_a = this.inputs) === null || _a === void 0 ? void 0 : _a.nativeElement) === null || _b === void 0 ? void 0 : _b.innerText) === null || _c === void 0 ? void 0 : _c.replace(new RegExp(this.query, 'g'), 
            // Using Color Code
            "<span style=\"background-color:" + this.color + "\">" + this.query + "</span>"));
        };
        return SearchHighlighterComponent;
    }());
    SearchHighlighterComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: SearchHighlighterComponent, deps: [{ token: i1__namespace.DomSanitizer }], target: i0__namespace.ɵɵFactoryTarget.Component });
    SearchHighlighterComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: SearchHighlighterComponent, selector: "ot-search-highlighter", inputs: { color: "color", query: "query" }, viewQueries: [{ propertyName: "inputs", first: true, predicate: ["inputs"], descendants: true, static: true }], usesOnChanges: true, ngImport: i0__namespace, template: "<!-- ORIGINAL CONTENT : hide original and display highlighted in below one -->\r\n<div #inputs [hidden]='true'>\r\n    <ng-content></ng-content>\r\n</div>\r\n\r\n<!-- REPLACED CONTENT -->\r\n<div class=\"gt-hl\" [innerHtml]='replacedInputText'></div>" });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: SearchHighlighterComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'ot-search-highlighter',
                        templateUrl: './search-highlighter.component.html',
                        styles: []
                    }]
            }], ctorParameters: function () { return [{ type: i1__namespace.DomSanitizer }]; }, propDecorators: { color: [{
                    type: i0.Input
                }], query: [{
                    type: i0.Input
                }], inputs: [{
                    type: i0.ViewChild,
                    args: ['inputs', { static: true }]
                }] } });

    var SearchHighlighterModule = /** @class */ (function () {
        function SearchHighlighterModule() {
        }
        return SearchHighlighterModule;
    }());
    SearchHighlighterModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: SearchHighlighterModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    SearchHighlighterModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: SearchHighlighterModule, declarations: [SearchHighlighterComponent], exports: [SearchHighlighterComponent] });
    SearchHighlighterModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: SearchHighlighterModule, imports: [[]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0__namespace, type: SearchHighlighterModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            SearchHighlighterComponent
                        ],
                        imports: [],
                        exports: [
                            SearchHighlighterComponent
                        ]
                    }]
            }] });

    /*
     * Public API Surface of search-highlighter
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.SearchHighlighterComponent = SearchHighlighterComponent;
    exports.SearchHighlighterModule = SearchHighlighterModule;
    exports.SearchHighlighterService = SearchHighlighterService;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=search-highlighter.umd.js.map
