import * as i0 from '@angular/core';
import { Injectable, Component, Input, ViewChild, NgModule } from '@angular/core';
import * as i1 from '@angular/platform-browser';

class SearchHighlighterService {
    constructor() { }
}
SearchHighlighterService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: SearchHighlighterService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
SearchHighlighterService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: SearchHighlighterService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: SearchHighlighterService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class SearchHighlighterComponent {
    constructor(sanitizer) {
        this.sanitizer = sanitizer;
        this.color = 'yellow'; // default yellow color
        this.query = '';
    }
    ngOnInit() {
        var _a, _b;
        // gets text from original content 
        this.replacedInputText = (_b = (_a = this.inputs) === null || _a === void 0 ? void 0 : _a.nativeElement) === null || _b === void 0 ? void 0 : _b.innerText;
    }
    /**
     * research on any changes in query/color
     */
    ngOnChanges() {
        this.search();
    }
    search() {
        var _a, _b, _c;
        // replacing the original content
        this.replacedInputText = this.sanitizer.bypassSecurityTrustHtml((_c = (_b = (_a = this.inputs) === null || _a === void 0 ? void 0 : _a.nativeElement) === null || _b === void 0 ? void 0 : _b.innerText) === null || _c === void 0 ? void 0 : _c.replace(new RegExp(this.query, 'g'), 
        // Using Color Code
        `<span style="background-color:${this.color}">${this.query}</span>`));
    }
}
SearchHighlighterComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: SearchHighlighterComponent, deps: [{ token: i1.DomSanitizer }], target: i0.ɵɵFactoryTarget.Component });
SearchHighlighterComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.16", type: SearchHighlighterComponent, selector: "ot-search-highlighter", inputs: { color: "color", query: "query" }, viewQueries: [{ propertyName: "inputs", first: true, predicate: ["inputs"], descendants: true, static: true }], usesOnChanges: true, ngImport: i0, template: "<!-- ORIGINAL CONTENT : hide original and display highlighted in below one -->\r\n<div #inputs [hidden]='true'>\r\n    <ng-content></ng-content>\r\n</div>\r\n\r\n<!-- REPLACED CONTENT -->\r\n<div class=\"gt-hl\" [innerHtml]='replacedInputText'></div>" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: SearchHighlighterComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'ot-search-highlighter',
                    templateUrl: './search-highlighter.component.html',
                    styles: []
                }]
        }], ctorParameters: function () { return [{ type: i1.DomSanitizer }]; }, propDecorators: { color: [{
                type: Input
            }], query: [{
                type: Input
            }], inputs: [{
                type: ViewChild,
                args: ['inputs', { static: true }]
            }] } });

class SearchHighlighterModule {
}
SearchHighlighterModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: SearchHighlighterModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
SearchHighlighterModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: SearchHighlighterModule, declarations: [SearchHighlighterComponent], exports: [SearchHighlighterComponent] });
SearchHighlighterModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: SearchHighlighterModule, imports: [[]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.16", ngImport: i0, type: SearchHighlighterModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        SearchHighlighterComponent
                    ],
                    imports: [],
                    exports: [
                        SearchHighlighterComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of search-highlighter
 */

/**
 * Generated bundle index. Do not edit.
 */

export { SearchHighlighterComponent, SearchHighlighterModule, SearchHighlighterService };
//# sourceMappingURL=search-highlighter.js.map
